#!/usr/bin/env python

# example helloworld.py

import pygtk
pygtk.require('2.0')
import gtk
from mapWidget import MapWidget
from osmData import OsmDataFile
from mapStyle import MapStyle

class HelloWorld:

    # This is a callback function. The data arguments are ignored
    # in this example. More on callbacks below.
    def hello(self, widget, data=None):
        print "Hello World"

    def delete_event(self, widget, event, data=None):
        # If you return FALSE in the "delete_event" signal handler,
        # GTK will emit the "destroy" signal. Returning TRUE means
        # you don't want the window to be destroyed.
        # This is useful for popping up 'are you sure you want to quit?'
        # type dialogs.
        print "delete event occurred"

        # Change FALSE to TRUE and the main window will not be destroyed
        # with a "delete_event".
        return False

    def destroy(self, widget, data=None):
        print "destroy signal occurred"
        gtk.main_quit()

    def MapLeftViewChanged(self, widget, data=None):
        print "left"
	self.mapRight.SetView(self.mapLeft.centrePos,self.mapLeft.zoom)

    def MapRightViewChanged(self, widget, data=None):
        print "right"
	self.mapLeft.SetView(self.mapRight.centrePos,self.mapRight.zoom)
        

    def __init__(self):
        # create a new window
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
    
        # When the window is given the "delete_event" signal (this is given
        # by the window manager, usually by the "close" option, or on the
        # titlebar), we ask it to call the delete_event () function
        # as defined above. The data passed to the callback
        # function is NULL and is ignored in the callback function.
        self.window.connect("delete_event", self.delete_event)
    
        # Here we connect the "destroy" event to a signal handler.  
        # This event occurs when we call gtk_widget_destroy() on the window,
        # or if we return FALSE in the "delete_event" callback.
        self.window.connect("destroy", self.destroy)
    
        # Sets the border width of the window.
        self.window.set_border_width(10)
    
        # Creates a new button with the label "Hello World".
        self.button = gtk.Button("Quit")
    
	self.vbox = gtk.VBox()
	self.mapPanes = gtk.HBox()

	self.mapLeft = MapWidget()
	self.mapRight = MapWidget()

	self.mapPanes.pack_start(self.mapLeft,True)
	self.mapPanes.pack_start(self.mapRight,True)	

	self.vbox.pack_start(self.mapPanes,True)
	self.vbox.pack_start(self.button,False)	

	self.mapLeft.connect("view_changed", self.MapLeftViewChanged, None)
	self.mapRight.connect("view_changed", self.MapRightViewChanged, None)

        # When the button receives the "clicked" signal, it will call the
        # function hello() passing it None as its argument.  The hello()
        # function is defined above.
        self.button.connect("clicked", self.hello, None)
    
        # This will cause the window to be destroyed by calling
        # gtk_widget_destroy(window) when "clicked".  Again, the destroy
        # signal could come from here, or the window manager.
        self.button.connect_object("clicked", gtk.Widget.destroy, self.window)
    
        # This packs the button into the window (a GTK container).
        self.window.add(self.vbox)
    
        # and the window
        self.window.show_all()

	#self.map.mapData = OsmDataFile("timscmap.osm.gz")
	self.mapLeft.mapData = OsmDataFile("timscmap.osm.gz")
	self.mapLeft.mapStyle = MapStyle("simple.css")
	self.mapRight.mapData = OsmDataFile("fosm.osm.gz")
	#self.mapRight.mapData = OsmDataFile("timscmap.osm.gz")
	self.mapRight.mapStyle = MapStyle("simple.css")
	#self.map.mapStyle = MapStyle("kothic.css")

    def main(self):
        # All PyGTK applications must have a gtk.main(). Control ends here
        # and waits for an event to occur (like a key press or mouse event).
        gtk.main()

# If the program is run directly or passed as an argument to the python
# interpreter then create a HelloWorld instance and show it
if __name__ == "__main__":
    hello = HelloWorld()
    hello.main()

